var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _temp;

function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

import { TYPES } from '@antv/l7-core';
import { inject, injectable } from 'inversify';
import { rgb2arr } from '../utils/color';
let DataMappingPlugin = (_dec = injectable(), _dec2 = inject(TYPES.IGlobalConfigService), _dec3 = inject(TYPES.ILogService), _dec(_class = (_class2 = (_temp = class DataMappingPlugin {
  constructor() {
    _initializerDefineProperty(this, "configService", _descriptor, this);

    _initializerDefineProperty(this, "logger", _descriptor2, this);
  }

  apply(layer, {
    styleAttributeService
  }) {
    layer.hooks.init.tap('DataMappingPlugin', () => {
      const attributes = styleAttributeService.getLayerStyleAttributes() || [];
      const {
        dataArray
      } = layer.getSource().data;

      if (!dataArray) {
        return;
      }

      layer.setEncodedData(this.mapping(attributes, dataArray));
    });
    layer.hooks.beforeRender.tap('DataMappingPlugin', () => {
      const attributes = styleAttributeService.getLayerStyleAttributes() || [];
      const {
        dataArray
      } = layer.getSource().data;
      const attributesToRemapping = attributes.filter(attribute => attribute.needRemapping);

      if (attributesToRemapping.length) {
        layer.setEncodedData(this.mapping(attributesToRemapping, dataArray));
        this.logger.debug('remapping finished');
      }
    });
  }

  mapping(attributes, data) {
    return data.map(record => {
      const encodeRecord = {
        id: record._id,
        coordinates: record.coordinates
      };
      attributes.forEach(attribute => {
        let values = this.applyAttributeMapping(attribute, record);
        attribute.needRemapping = false;

        if (attribute.name === 'color') {
          values = values.map(c => {
            return rgb2arr(c);
          });
        }

        encodeRecord[attribute.name] = Array.isArray(values) && values.length === 1 ? values[0] : values;
      });
      return encodeRecord;
    });
  }

  applyAttributeMapping(attribute, record) {
    var _attribute$scale;

    if (!attribute.scale) {
      return [];
    }

    const scalers = (attribute === null || attribute === void 0 ? void 0 : (_attribute$scale = attribute.scale) === null || _attribute$scale === void 0 ? void 0 : _attribute$scale.scalers) || [];
    const params = [];
    scalers.forEach(({
      field
    }) => {
      var _attribute$scale2;

      if (record.hasOwnProperty(field) || ((_attribute$scale2 = attribute.scale) === null || _attribute$scale2 === void 0 ? void 0 : _attribute$scale2.type) === 'variable') {
        params.push(record[field]);
      }
    });
    return attribute.mapping ? attribute.mapping(params) : [];
  }

}, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "configService", [_dec2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "logger", [_dec3], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
})), _class2)) || _class);
export { DataMappingPlugin as default };
//# sourceMappingURL=DataMappingPlugin.js.map