"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _l7Core = require("@antv/l7-core");

var _inversify = require("inversify");

var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

let ShaderUniformPlugin = (_dec = (0, _inversify.injectable)(), _dec2 = (0, _inversify.inject)(_l7Core.TYPES.ICameraService), _dec3 = (0, _inversify.inject)(_l7Core.TYPES.ICoordinateSystemService), _dec4 = (0, _inversify.inject)(_l7Core.TYPES.IRendererService), _dec(_class = (_class2 = (_temp = class ShaderUniformPlugin {
  constructor() {
    _initializerDefineProperty(this, "cameraService", _descriptor, this);

    _initializerDefineProperty(this, "coordinateSystemService", _descriptor2, this);

    _initializerDefineProperty(this, "rendererService", _descriptor3, this);
  }

  apply(layer) {
    layer.hooks.beforeRender.tap('ShaderUniformPlugin', () => {
      this.coordinateSystemService.refresh();
      const {
        width,
        height
      } = this.rendererService.getViewportSize();
      layer.models.forEach(model => model.addUniforms({
        [_l7Core.CameraUniform.ProjectionMatrix]: this.cameraService.getProjectionMatrix(),
        [_l7Core.CameraUniform.ViewMatrix]: this.cameraService.getViewMatrix(),
        [_l7Core.CameraUniform.ViewProjectionMatrix]: this.cameraService.getViewProjectionMatrix(),
        [_l7Core.CameraUniform.Zoom]: this.cameraService.getZoom(),
        [_l7Core.CameraUniform.ZoomScale]: this.cameraService.getZoomScale(),
        [_l7Core.CameraUniform.FocalDistance]: this.cameraService.getFocalDistance(),
        [_l7Core.CameraUniform.CameraPosition]: this.cameraService.getCameraPosition(),
        [_l7Core.CoordinateUniform.CoordinateSystem]: this.coordinateSystemService.getCoordinateSystem(),
        [_l7Core.CoordinateUniform.ViewportCenter]: this.coordinateSystemService.getViewportCenter(),
        [_l7Core.CoordinateUniform.ViewportCenterProjection]: this.coordinateSystemService.getViewportCenterProjection(),
        [_l7Core.CoordinateUniform.PixelsPerDegree]: this.coordinateSystemService.getPixelsPerDegree(),
        [_l7Core.CoordinateUniform.PixelsPerDegree2]: this.coordinateSystemService.getPixelsPerDegree2(),
        [_l7Core.CoordinateUniform.PixelsPerMeter]: this.coordinateSystemService.getPixelsPerMeter(),
        u_ViewportSize: [width, height],
        u_DevicePixelRatio: window.devicePixelRatio,
        u_ModelMatrix: [1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1]
      }));
    });
  }

}, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "cameraService", [_dec2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "coordinateSystemService", [_dec3], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "rendererService", [_dec4], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
})), _class2)) || _class);
exports.default = ShaderUniformPlugin;
//# sourceMappingURL=ShaderUniformPlugin.js.map